package com.qq.xwvoicesdk;

import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.qq.wx.voice.evad.TRSilkDecoder;
import com.qq.wx.voice.evad.TRSilkEncoder;
import com.qq.wx.voice.evad.WXVoiceLibLoad;

public class MainActivity extends AppCompatActivity {

    String Tag = "SilkDebug";
    TRSilkEncoder trSilkEncoder = new TRSilkEncoder();
    TRSilkDecoder trSilkDecoder = new TRSilkDecoder();

    private AudioRecorder audioRecorder = new AudioRecorder(buffer -> {
        Log.d(Tag, "silkEncode before buffer len: " + buffer.length );
        byte[] outSilk = trSilkEncoder.processPCMToSilk(buffer);
        if (outSilk == null)
            outSilk = new byte[0];
        Log.d(Tag, "silkEncode after buffer len: " + outSilk.length );

        byte[] outPcm = trSilkDecoder.processSilkToPCM(outSilk);
        if (outPcm == null)
            outPcm = new byte[0];

        Log.d(Tag, "silkDecode after buffer len: " + outPcm.length );
    });


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        WXVoiceLibLoad.loadLibrary();
    }

    public void onClickStartRecord(View view) {

        audioRecorder.startRecord(this);
    }

    public void onClickStopRecord(View view) {
        audioRecorder.stopRecording();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        audioRecorder.stopRecording();
    }
}